/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner{}

// AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner struct for AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner
type AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner struct {
	Host      *string `json:"host,omitempty"`
	Label     *string `json:"label,omitempty"`
	ServiceId *string `json:"serviceId,omitempty"`
}

// NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner instantiates a new AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner {
	this := AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner{}
	var label string = "Microsoft Dynamics 365"
	this.Label = &label
	var serviceId string = "microsoft_dynamics365"
	this.ServiceId = &serviceId
	return &this
}

// NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInnerWithDefaults instantiates a new AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInnerWithDefaults() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner {
	this := AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner{}
	var label string = "Microsoft Dynamics 365"
	this.Label = &label
	var serviceId string = "microsoft_dynamics365"
	this.ServiceId = &serviceId
	return &this
}

// GetHost returns the Host field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) GetHost() string {
	if o == nil || IsNil(o.Host) {
		var ret string
		return ret
	}
	return *o.Host
}

// GetHostOk returns a tuple with the Host field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) GetHostOk() (*string, bool) {
	if o == nil || IsNil(o.Host) {
		return nil, false
	}
	return o.Host, true
}

// HasHost returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) HasHost() bool {
	if o != nil && !IsNil(o.Host) {
		return true
	}

	return false
}

// SetHost gets a reference to the given string and assigns it to the Host field.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) SetHost(v string) {
	o.Host = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) SetLabel(v string) {
	o.Label = &v
}

// GetServiceId returns the ServiceId field value if set, zero value otherwise.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) GetServiceId() string {
	if o == nil || IsNil(o.ServiceId) {
		var ret string
		return ret
	}
	return *o.ServiceId
}

// GetServiceIdOk returns a tuple with the ServiceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) GetServiceIdOk() (*string, bool) {
	if o == nil || IsNil(o.ServiceId) {
		return nil, false
	}
	return o.ServiceId, true
}

// HasServiceId returns a boolean if a field has been set.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) HasServiceId() bool {
	if o != nil && !IsNil(o.ServiceId) {
		return true
	}

	return false
}

// SetServiceId gets a reference to the given string and assigns it to the ServiceId field.
func (o *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) SetServiceId(v string) {
	o.ServiceId = &v
}

func (o AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Host) {
		toSerialize["host"] = o.Host
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ServiceId) {
		toSerialize["serviceId"] = o.ServiceId
	}
	return toSerialize, nil
}

type NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner struct {
	value *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner
	isSet bool
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) Get() *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner {
	return v.value
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) Set(val *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner(val *AppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner {
	return &NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner{value: val, isSet: true}
}

func (v NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerMicrosoftDynamics365MicrosoftDynamics365AuthorizerOAuthRequestURLRequestConfigInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
